// $Id$
/**
* Copyright (C) 2015 EDIT
* European Distributed Institute of Taxonomy
* http://www.e-taxonomy.eu
*
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/
package eu.etaxonomy.taxeditor.editor;

import java.util.HashMap;
import java.util.Map;

import org.apache.log4j.Logger;
import org.eclipse.ui.PartInitException;

import eu.etaxonomy.cdm.model.occurrence.SpecimenOrObservationBase;
import eu.etaxonomy.cdm.model.taxon.TaxonBase;
import eu.etaxonomy.taxeditor.editor.view.derivate.DerivateView;
import eu.etaxonomy.taxeditor.model.MessagingUtils;
import eu.etaxonomy.taxeditor.view.ICdmViewer;

/**
 * @author pplitzner
 * @date Feb 23, 2015
 *
 */
public class EditorCdmViewer implements ICdmViewer {

    private final Logger logger = Logger.getLogger(EditorCdmViewer.class);

    /* (non-Javadoc)
     * @see eu.etaxonomy.taxeditor.view.ICdmViewer#show(java.lang.Object)
     */
    @Override
    public void show(Object input, Class<?> viewerClass) {
        try {
            if(viewerClass.equals(MultiPageTaxonEditor.class)){
                if(input instanceof TaxonBase){
                    TaxonEditorInput editorInput = TaxonEditorInput.NewInstanceFromTaxonBase(((TaxonBase<?>) input).getUuid());
                    EditorUtil.open(editorInput);
                }
            }
            else if(viewerClass.equals(DerivateView.class)){
                if(input instanceof SpecimenOrObservationBase){
                }
            }
        } catch (PartInitException e) {
            String errorMessage = "Could not open editor";
            logger.error(errorMessage, e);
            MessagingUtils.error(EditorCdmViewer.class, errorMessage, e);
        }
    }

    /* (non-Javadoc)
     * @see eu.etaxonomy.taxeditor.view.ICdmViewer#getViewerClasses(java.lang.Object)
     */
    @Override
    public Map<Class<?>, String> getViewerClasses(Object input) {
        Map<Class<?>, String> viewerNameMap = new HashMap<Class<?>, String>();
        if(input instanceof TaxonBase){
            viewerNameMap.put(MultiPageTaxonEditor.class, "Taxon Editor");
        }
        return viewerNameMap;
    }

}
