package eu.etaxonomy.taxeditor.editor.handler;
import org.eclipse.core.commands.AbstractHandler;
import org.eclipse.core.commands.ExecutionEvent;
import org.eclipse.core.commands.ExecutionException;
import org.eclipse.core.commands.ParameterType;
import org.eclipse.core.commands.common.NotDefinedException;
import org.eclipse.ui.PartInitException;

import eu.etaxonomy.taxeditor.editor.EditorUtil;
import eu.etaxonomy.taxeditor.model.MessagingUtils;


public class OpenTaxonEditorHandler extends AbstractHandler {

    @Override
    public Object execute(ExecutionEvent event) throws ExecutionException {
        Object object = event.getObjectParameterForExecution("eu.etaxonomy.taxeditor.editor.taxonParameter");

        try {
            ParameterType parameterType = event.getCommand().getParameterType("eu.etaxonomy.taxeditor.editor.taxonParameter");
            if(parameterType.isCompatible(object)){
                EditorUtil.openTaxonEditor(object);
            }
        } catch (NotDefinedException e) {
            MessagingUtils.error(this.getClass(), "Parameter type not defined", e);
        } catch (PartInitException e) {
            MessagingUtils.error(OpenTaxonEditorHandler.class, "Error opening the editor", e);
        }
        return null;
    }

}
